<%--
 * Component: iface
 *
 * Description:
 *    HTTP interface to delete specified object
 *
 *  @param cStudy       Study Instance UID of the study the object belongs to
 *  @param cObject      SOP Instance UID of the object to delete
 *
 * Last Updated     : $Author$
 * Update date/time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
--%><%@page import="imagemed.jsputil.RedirectToolbox"%><%@
	page import="java.util.*, java.sql.*, imagemed.imsession.*, imagemed.dcprocessing.StudyRemover,
			imagemed.jsputil.IfaceToolbox, imagemed.util.Helper, imagemed.types.flag.IMTypeur"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%IMSession is = new IMSession( request, response, out );
	if ( !IfaceToolbox.isRegOK( is ) ) {
		IfaceToolbox.printError( is, "Has no registration info for this IP." );
		return;
	}

	String parStudy = request.getParameter( "cStudy" );
	String parObject[] = request.getParameterValues( "cObject" );

	if ( parStudy == null || parStudy.length() == 0 ) {
		IfaceToolbox.printError( is, "Required parameter 'cStudy' is missing." );
		return;
	}

	if ( parObject == null || parObject.length == 0 || parObject[ 0 ] == null || parObject[ 0 ].length() == 0 ) {
		IfaceToolbox.printError( is, "Required parameter 'cObject' is missing." );
		return;
	}

	if ( !is.hasRight( IMTypeur.DELETE_RIGHT ) ) {
		IfaceToolbox.printError( is, "Has no access rights to delete objects." );
		return;
	}

	String redirHost = RedirectToolbox.getRedirectForStudy(is, parStudy);
	
	if (redirHost != null) {
		String redirURL = redirHost + "/iface/deleteObject.jsp?" + RedirectToolbox.getRedirectParams( is );
		response.sendRedirect(redirURL);
		return;
	}

	String fname = null;
	try {
		Vector<String> vFile = new Vector<String>();
		
		StringBuilder inClause = new StringBuilder( 256 );
		for ( String sopi: parObject ) {
			if ( sopi == null ) {
				continue;
			}
			
			inClause.append( ",'" ).append( sopi ).append( "'" );
		}

		ResultSet resObj = IMEnv.getDB().prepareStatement( "SELECT FNAME from " + IMEnvBase.getEnv( "OBJECTTBL" ) +
				" WHERE STYIUID='" + parStudy + "' AND SOPIUID IN (" + inClause.substring( 1 ) + ")" ).executeQuery();

		while ( resObj.next() ) {
			fname = resObj.getString( "FNAME" );  
			vFile.add( fname );
		}
		resObj.close();
		
		if ( vFile.isEmpty() ) {
			IfaceToolbox.printError( is, "No object to delete." );
			return;
		}
		
		Helper.INFOLOG( "Deleting " + parStudy + " " + vFile );
		
		if ( StudyRemover.rmiRemoveFiles( null, parStudy, is.regID, vFile, "Delete user selected object(s)", Boolean.TRUE ).booleanValue() ) {
			IfaceToolbox.printOK( is );
			return;
		}
	}
	catch ( Throwable th ) {
		Helper.ERRORLOG( "deleteObject", "An error occurred while trying to delete " + parObject + " (" + fname + ") from " + parStudy + ": " + Helper.throwable2String( th ) );
	}

	IfaceToolbox.printError( is, "An error occurred while deleting the object" );
	if ( true ) {
		return;
	}%>