<%--
 ** Component: iface
 **
 ** Description:
 **   Device setting interface
 **
 ** Parameters:
 **
 **  Difficult
 **
 ** $Author$
 ** $Date$
 **
 *
 *  RCS File Name    : $RCSfile$
 *  RCS Revision     : $Revision$
 *  Locked by        : $Locker$
 *  Symbolic name    : $Name$
 *  State            : $State$
--%><%@page import="imagemed.http.tabs.TabBean"%>
<%@
	page import="java.sql.*,java.util.*,imagemed.exception.*,imagemed.util.*,imagemed.imsession.*,imagemed.http.*,imagemed.jsputil.*"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%-- --- Helper Function(s) --- --%><%!

	String targetTable       = IMEnvBase.getEnv("TARGETTBL");
	String deviceServiceTable      = IMEnvBase.getEnv("DEVSERVTBL");

	public void encodeDevicesName(IMSession is) throws Throwable	{
		PreparedStatement existingID = IMEnv.getDB().prepareStatement("SELECT 'true' FROM " + targetTable + " WHERE ID=?");
		ResultSet rs;
		List<String> devNameBeforeConversion = new ArrayList<String>();
		List<String> devNameAfterConversion = new ArrayList<String>();
		
		if (is.imRequest == null) is.imRequest = new IMRequest(is.request);
		is.imRequest.initParSeq();
		while (is.imRequest.hasMoreParNames()) {
			String parName = is.imRequest.nextParName();
			if ( parName.indexOf('>')==-1 )	continue;
			
			devNameBeforeConversion.add(parName);
			
			int separator = parName.indexOf('>');
			char objType = parName.charAt(0);
			String srcID = parName.substring(1, separator);
			String trgID = parName.substring(separator + 1);
			
			if ( ! "LOCAL".equals(srcID)) {
				existingID.setString(1, srcID);
				rs = existingID.executeQuery();
				if ( ! rs.next() )
					throw new IMIfaceException(is,"Non existing device ID : "+srcID);
			}
			existingID.setString(1, trgID);
			rs = existingID.executeQuery();
			if ( ! rs.next() )
				throw new IMIfaceException(is,"Non existing device ID : "+trgID);
			
			String src = Helper.encodeByRty(srcID);
			String trg = Helper.encodeByRty(trgID);
			devNameAfterConversion.add( objType + src + "X" + trg );
		}
		
		
		for (int i=0; i<devNameBeforeConversion.size(); i++)	{
			is.imRequest.setProperty(devNameAfterConversion.get(i), is.imRequest.getVal(devNameBeforeConversion.get(i)) );
			is.imRequest.delProperty(devNameBeforeConversion.get(i));
		}
	}
	
%><%IMSession is = new IMSession(request, response, out);

// ********** Input Parameters *********
	MultipartRequest mp = new MultipartRequest( is, IMEnvBase.getEnv("TMP") );

	String parId       = mp.getParameter("p_id");
	String parHost     = mp.getParameter("p_host");
	String parPort     = mp.getParameter("p_port");
	String parProtocol = mp.getParameter("p_protocol");
	String parType     = mp.getParameter("p_type");
	String parCategory = mp.getParameter("p_category");
	String parOp       = mp.getParameter("p_op");
	String parPsc      = mp.getParameter("p_psc");

// ********** Init *********

	String reportWorkflowCfg = IMEnvBase.getEnv("IFACE_REPORT_CONFIG_FILE");
	String orderWorkflowCfg  = IMEnvBase.getEnv("IFACE_ORDER_CONFIG_FILE");
	boolean pbscpCfg = false;
	boolean chHL7Cfg = false;

	if ( parId       == null )   parId       = "";
	if ( parHost     == null )   parHost     = "";
	if ( parPort     == null )   parPort     = "104";
	if ( parProtocol == null )   parProtocol = "T";
	if ( parCategory == null )   parProtocol = DicomToolbox.DEFAULTDEVICECATEGORY_WAN;
	if ( parType     == null ) {
		if (parId.length() == 0) {
			parType     = "D";
		}
		else {
			parType = DicomToolbox.getType(parId);
			if (parType == null) {
				parType     = "D";
			}
		}
	}

//*** Check License
	// in fact, this could be in RegOK(), but I didn't want to change too much things because of a concrete problem (CBT 2477)
	try {
		TabBean.checkLicense( is, true );
	}
	catch( IMException ie ) {
		IfaceToolbox.printError( is, "License problem!" ); 
		return;
	}

	int nFlags = 0xFFFFFFFF;
	try { nFlags = Integer.parseInt(is.sessionVariables.getProperty("CTFlags")); }
	catch (Throwable t) {};
	boolean licHR = (nFlags & 1)!=0 ;

	response.setContentType("text/plain");

try{
	
	if (!IfaceToolbox.isRegOK(is))
		throw new IMIfaceException(is,"Has no registration info for this IP.");
				
	if (!IMAdminToolbox.bAdminRight(is))
		throw new IMIfaceException(is,"Has no Admin right for this operation.");

	boolean isRestricted = is.regRights.indexOf("@") == -1;

  if ( parOp == null )
		throw new IMIfaceException(is,"Operation lost.");
  
// ********** Save Printer Config *********

	if (parOp.equals("Change")) {
		DicomToolbox.setDicomPrinterCfg(mp.getParameter("pr_cfg"));
		is.out.println("#USERID: "+is.regID);
		is.out.println("#RESULT: OK");
		return;
	}

// ********** Deleting *********
	if (parOp.startsWith("Delete")) {
		if (("P".equals(parType) || "C".equals(parType)) && isRestricted) {
			throw new IMIfaceException(is,"Has no Support right for this operation.");
		}
		DicomToolbox.removeDevice(parId);
		is.out.println("#USERID: "+is.regID);
		is.out.println("#RESULT: OK");
		return;
	}

// ********** Editing and adding device *********

	if ( "addDevice".equals(parOp) || "editDevice".equals(parOp) ) {
		int todo=0;
		if ( "addDevice".equals(parOp))
			todo = DicomToolbox.addDeviceIface(is,mp);
		if("editDevice".equals(parOp))
			todo = DicomToolbox.editDeviceIface(is,mp);
		if (todo == DicomToolbox.NOTHING) {
			is.out.println("#USERID: "+is.regID);
			is.out.println("#RESULT: OK");
			return;
		}
		else{
			if ((todo & DicomToolbox.STORESCPRESTART)!=0){
				pbscpCfg = true;
			}
			else{
				chHL7Cfg = true;
				is.out.println("HL& restart");
			}
		}
	}

// ********** DICOM Services table processing *********

	SystemConfig cfg = new SystemConfig();
	boolean isPsc = cfg.getPromiscuousMode() == DeviceConfig.DcBool.TRUE;

	IMProperties mwlCf = new IMProperties();
	mwlCf.recRead( IMEnvBase.getEnv("DICOM_VAR") + "/mwl.cfg" );
	mwlCf.remove("PEER"); mwlCf.remove("PORT"); mwlCf.remove("AE_TITLE");
	String mwlFrom      = mwlCf.getProperty("FROM_DAYS","-1");
	String mwlTo        = mwlCf.getProperty("TO_DAYS","1");

	if ( "dcmServ".equals(parOp) ) {

		isPsc = ("true".equals(parPsc));
		cfg.setPromiscuousMode(isPsc ? DeviceConfig.DcBool.TRUE : DeviceConfig.DcBool.FALSE);
		pbscpCfg = true;

		mwlFrom  = mp.getParameter("p_MWLfrom");
		mwlTo    = mp.getParameter("p_MWLto");
		mwlCf.setProperty("FROM_DAYS",mwlFrom);
		mwlCf.setProperty("TO_DAYS",mwlTo);
		mwlCf.recWrite(IMEnvBase.getEnv("DICOM_VAR") + "/mwl.cfg");
		is.out.println("#USERID: "+is.regID);
		is.out.println("#RESULT: OK");
		return;
	}
// ********** HL7 Message table processing *********
	if ( "HL7msg".equals(parOp) ) {
		if (!licHR)
			throw new IMIfaceException(is,"HIS/RIS is not licensed.");

		Helper.writeTextFile( IMEnvBase.getEnv("HL7_SORTER_VMD_FILE"), mp.getParameter("vmdSorter") );
		chHL7Cfg = true;
	}


// ********** Report Workflow table processing *********
	if ( "wfRep".equals(parOp) ) {
		if (!licHR)
			throw new IMIfaceException(is,"HIS/RIS is not licensed.");
		
		encodeDevicesName(is);
		DicomToolbox.ifaceProcessWFTable( DicomToolbox.REPORT, is );
		Helper.writeTextFile( reportWorkflowCfg, DicomToolbox.getIfaceConfig(DicomToolbox.REPORT) );
		chHL7Cfg = true;
	}

// ********** Order Workflow table processing *********
	if ( "wfOrd".equals(parOp) ) {
		if (!licHR)
			throw new IMIfaceException(is,"HIS/RIS is not licensed.");

		encodeDevicesName(is);
		DicomToolbox.ifaceProcessWFTable( DicomToolbox.ORDER, is );
		Helper.writeTextFile( orderWorkflowCfg, DicomToolbox.getIfaceConfig(DicomToolbox.ORDER) );
		chHL7Cfg = true;
	}

// ********** Set a single entry in the message flow tables (report/order) *********
	if ( "msgFlow".equals(parOp) ) {
		if (!licHR)
			throw new IMIfaceException(is,"HIS/RIS is not licensed.");
		
		String parEvent = mp.getParameter("event");
		String parSourceDevice = mp.getParameter("source");
		String parTargetDevice = mp.getParameter("target");
		String parValue = mp.getParameter("value");
		if (parEvent == null || parSourceDevice == null || parTargetDevice == null || parValue == null)
			throw new IMIfaceException(is, "Missing parameter for setting message flow entry");

		if(!"true".equals(parValue) && !"false".equals(parValue)) {
			throw new IMIfaceException(is, "Invalid value for message flow entry");
		}

		String msgType = DicomToolbox.setMessageFlowFlag(parEvent, parSourceDevice, parTargetDevice, "true".equals(parValue));
		if (("" + DicomToolbox.REPORT).equals(msgType)) {
			Helper.writeTextFile( reportWorkflowCfg, DicomToolbox.getIfaceConfig(DicomToolbox.REPORT) );
		}
		else if (("" +DicomToolbox.ORDER).equals(msgType)) {
			Helper.writeTextFile( orderWorkflowCfg, DicomToolbox.getIfaceConfig(DicomToolbox.ORDER) );
		}
		chHL7Cfg = true;
	}
	
// ********** Refresh IP may change HL7 Config *********
	if ( "refreshIP".equals(parOp) ) {
		DicomToolbox.writeHL7Cfg();
		Helper.writeTextFile( reportWorkflowCfg, DicomToolbox.getIfaceConfig('r') );
		Helper.writeTextFile( orderWorkflowCfg, DicomToolbox.getIfaceConfig('o') );
		chHL7Cfg = true;
	}

// ********** (confirmed) Restart components *********
	if ( pbscpCfg || chHL7Cfg ||
			"restart".equals(parOp) && mp.getParameter("p_restart")!=null )	{
		
		List<String> comps = new LinkedList<String>();
		if ("restart".equals(parOp) || chHL7Cfg)	{
			String component = mp.getParameter("p_restart");
			if (("hl7".equals(component) || chHL7Cfg) && licHR){
				comps.add("hl7");
			}	
			else if ("dicom".equals(component))
			  comps.add("dicom");
			else
				throw new IMIfaceException(is,"Prohibited component for restart:"+component);
		}
		if ( pbscpCfg ) {
			cfg.save();
			if ( !comps.contains("dicom") )
				comps.add("dicom");
		}
		if ( chHL7Cfg && (licHR && !comps.contains("hl7"))){
			
		  comps.add("hl7");
			
		}
		String[] compRestart = comps.toArray( new String[0] );
		
		if ( null!=compRestart && 0 < compRestart.length ) {
			String   home = IMEnvBase.getEnv("HOME");
			String[] env  = { "HOME=" + home };
			String[] cmd  = new String[2];

			for (int i=0; i<compRestart.length; i++) {
				cmd[0] = home +"/component/"+ compRestart[i] +"/ctrl";
				cmd[1] = "stop";
				Helper.runCommand(cmd,env);
				Thread.sleep(2000);
				cmd[1] = "start";
				is.out.println(home +"/component/"+ compRestart[i] + "/ctrl");
				Helper.runCommand(cmd,env);
			}
		}

		is.out.println("#USERID: "+is.regID);
		is.out.println("#RESULT: OK");
		return;
	}	//Restart
	
// ********** HL7 Config Checking *********

	if ( "HL7cfgCheck".equals(parOp) ) {
		String[] cmd  = { IMEnvBase.getEnv("HL7_HOME")+"/bin/testConfig.sh" };
		String[] env  = { "HOME=" + IMEnvBase.getEnv("HOME") };

		RunCommandResult res = Helper.runCommandEx(cmd,env);
		if (res.getExitCode() != 0) {
			String resultTxt = Helper.htmlEncode(res.getOutput(), false,true) +
				Helper.htmlEncode(res.getError(), false,true);
			if ("".equals(resultTxt))
				resultTxt = "HL7 Config is not consistent.";
			throw new IMIfaceException(is,resultTxt);
		}

		is.out.println("#USERID: "+is.regID);
		is.out.println("#RESULT: OK");
		return;
	}

	if (true)	throw new IMIfaceException(is,"Unknown operation:"+parOp);

} catch (IMIfaceException imi) {
	is.out.print( imi.getFormattedMessage() );
	return;
} catch (IMGeneralException ge) {
	IMIfaceException imi = new IMIfaceException(is, ge.getPlainText() );
	is.out.print( imi.getFormattedMessage() );
	return;	
} catch (Throwable t) {
	IMIfaceException imi = new IMIfaceException(is,t.getMessage());
	is.out.print( imi.getFormattedMessage() );
	return;
}%>
