
<%@page import="imagemed.http.Range"%><%--
 * Component: iface
 *
 * Description:
 *   Retrieves the dictation for a report or addendum
 *
 * Parameters:
 *
 *  @param cReport           The Report ID of the report or addendum as returned by report.jsp.
 *
 * When successful, it returns the .wav file of the recorded dictation.
 *
 * Last Updated     : $Author$
 * Update date/time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
--%><%@
	page import="imagemed.util.*,imagemed.imsession.*,imagemed.jsputil.*,java.util.*,java.sql.*,java.io.*"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%!

	static imagemed.types.enumeration.IMTypeISTI typeSI   = new imagemed.types.enumeration.IMTypeISTI();
	static imagemed.types.string.IMTypePN typePN = new imagemed.types.string.IMTypePN();

%><%

	IMSession is = new IMSession(request, response, out);

	// Check login
	if (!IfaceToolbox.isRegOK(is)) {
		IfaceToolbox.printError(is, "Has no registration info for this IP.");
		return;
	}

	String parReport = request.getParameter("cReport");

	String study = null;
	String reportSopiuid = null;
	try {
		ResultSet rs = IMEnv.getDB().prepareStatement("select SRCSTUDY, INTSOPIUID from " + IMEnvBase.getEnv("REPORTTBL") +
				" where SOPIUID='" + parReport + "'").executeQuery();
		if (rs.next()) {
			study = rs.getString("SRCSTUDY");
			reportSopiuid = rs.getString("INTSOPIUID");
		}
		rs.close();
	}
	catch (SQLException sqlEx) {
	}

	if (study == null || reportSopiuid == null) {
		IfaceToolbox.printError(is, "Report not found.");
		return;
	}

	String studyDirName = RepositoryHandler.getLocation(RepositoryHandler.DATA, study);
	ReportToolbox.moveOldReportToDicomData(studyDirName, study);

	Properties prpHeaders = new Properties();
	Properties prpTimes = Report.getReportModified(is, study, "None", prpHeaders);

	int nWaitTime = 30000;
	int nElapsed = 0;

	while (ReportToolbox.hasNewerReport(prpTimes, study) && nElapsed < nWaitTime) {
		Thread.sleep(50);
		nElapsed += 50;
	}

	if (ReportToolbox.hasNewerReport(prpTimes, study)) {
		IfaceToolbox.printError(is, "The report is not up to date, was modified.");
		return;
	}

	Properties results     = new Properties();
	Vector<Properties> interpretations = new Vector<Properties>();
	Vector<Properties> externals       = new Vector<Properties>();

	if (is.sessionVariables == null)
		is.sessionVariables = new Properties();
	is.sessionVariables.setProperty("study", study);

	int res = ReportToolbox.parseReport(is, results, interpretations, externals);
	if (res == ReportToolbox.PR_INVALID_VERSION) {
		// This should not be happen with new (SR) reports
		// itt meg lehetne hivni a convertert, es ujra probalkozni
		IfaceToolbox.printError(is, "Invalid report version.");
		return;
	}
	else if (res == ReportToolbox.PR_ERROR) {
		IfaceToolbox.printError(is, "Could not read report.");
		return;
	}

	String dictation = null;
	for (int i = 0; i < interpretations.size(); i++) {
		Properties interpretation = interpretations.elementAt(i);

		String sopiuid = interpretation.getProperty("sopiuid", "");
		if (sopiuid.equals(reportSopiuid)) {
			dictation = interpretation.getProperty("dictuid");
			break;
		}
	}

	if (dictation == null) {
		IfaceToolbox.printError(is, "Dictation not found.");
		return;
	}

	String dictationFileName = RepositoryHandler.getLocation(RepositoryHandler.CACHE, study) + "/" + dictation + ".wav"; 
	File dictationFile = new File( dictationFileName );
	if (!dictationFile.exists()) {
		IfaceToolbox.printError(is, "Dictation file does not exist.");
		return;
	}

	response.setContentType("audio/x-wav");

	Range range = new Range( request, response );
	range.sendRequestedRange( dictationFileName );

	/*
	response.setContentLength((int) dictationFile.length());
	InputStreamReader reader = new InputStreamReader(new FileInputStream(dictationFile), "ISO-8859-1");
	char buffer[] = new char[4096];
	int  read = -1;
	while (-1 != (read = reader.read(buffer))) {
		out.write(buffer, 0 , read);
	}
	reader.close();
	*/
	
	out.flush();


	if (true)
		return;
%>
