<%@page import="imagemed.dotcom.DotcomConfig"%><%@page import="imagemed.util.Helper"%><%@page import="imagemed.http.Range"%><%--
 * Component: iface
 *
 * Description:
 *   Retreives an image frame in a given format (jpg, raw)
 *
 * Parameters:
 *
 * cObj        SOP IUID of the object to query.
 * cFrame      The index of the frame to query. Default is 1.
 * cFormat     The format of the frame to query, must be raw or jpg. Default is jpg.
 * cMode       Defines the desired processing. Default is unprocessed.
 *               w apply default Window/Level, and return the resulting 8 bit image.
 *               r add annotations and present it as it appears as key image.
 * cRef        The reference for key image (if cMode was r). Default is 1. See report.jsp
 * cStudy			 Required for object-less CWL only! - the StudyIUID of the study
 *
 * When successful, it returns the image file.
 *
 * Last Updated     : $Author$
 * Update date/time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
--%><%@
	page import="imagemed.imsession.*,imagemed.jsputil.*,java.io.*,imagemed.dcprocessing.Frame, java.sql.*"

%><%@
  page errorPage ="../main/exceptionHandler.jsp"

%><%

	IMSession is = new IMSession( request, response, out );

	// Check login
	if ( !IfaceToolbox.isRegOK( is ) ) {
		IfaceToolbox.printError( is, "Has no registration info for this IP." );
		return;
	}

%><%
	String parObj    = request.getParameter( "cObj" );
	String parFrame  = request.getParameter( "cFrame" );
	String parFormat = request.getParameter( "cFormat" );
	String parMode   = request.getParameter( "cMode" );
	String parRef    = request.getParameter( "cRef" );
	String parSize   = request.getParameter( "cSize" );
	String parStudy  = request.getParameter( "cStudy" );

	Helper.DEBUG( "frame.jsp called BUU" );
	
	if ( parFormat == null )
		parFormat = "jpg";

	if ( parMode == null )
		parMode = "";

	if ( parObj == null ) {
		IfaceToolbox.printError( is, "Missing parameter: cObj" );
		return;
	}

	String study      = null;
	String objectName = null;
	if( DotcomConfig.selfDevice().isNoObjectTable() ) {
		study = parStudy;		
	}
	else {
		try {
			String query = "select STYIUID, FNAME from " + IMEnvBase.getEnv( "OBJECTTBL" ) +
					" where SOPIUID='" + parObj + "'";
			Helper.DEBUG( "query:" + query );
			ResultSet rs = IMEnv.getDB().prepareStatement( query ).executeQuery();
			if ( rs.next() ) {
				study      = rs.getString( "STYIUID" );
				objectName = rs.getString( "FNAME" );
			}
			rs.close();
		}
		catch ( SQLException sqlEx ) {
		}

	}

	Helper.DEBUG( "study:" + study + " objectname:" + objectName );

	if ( study == null ) {
		IfaceToolbox.printError( is, "Study not found." );
		return;
	}

	String redirHost = RedirectToolbox.getRedirectForStudy(is, study);
	
	Helper.DEBUG( "redirhost:" + redirHost );
	
	if (redirHost != null) {
		String redirURL = redirHost + "/iface/frame.jsp?" + RedirectToolbox.getRedirectParams( is );
		response.sendRedirect(redirURL);
		return;
	}

	if ( objectName == null ) {
		IfaceToolbox.printError( is, "Object not found." );
		return;
	}

//	if ( ProxyToolbox.checkAndProxy(is,study,true) ) {
//		logger.syslog(Syslog.LOG_DEBUG,"checkAndProxy is true");
//		return;
//	}

//	logger.syslog(Syslog.LOG_DEBUG,"Create Response");

	String fname = "";

	// check if the image exists and create it if doesn't exist
	try {
//		boolean bReprocess= request.getHeader("PBReprocess") != null;
//		logger.syslog(Syslog.LOG_DEBUG,"Reprocess flag: "+ bReprocess);

		int frame = 1;
		try {
			frame = Integer.parseInt( parFrame );
		}
		catch ( Throwable th ) {
		}

		int ref = 1;
		try {
			ref = Integer.parseInt( parRef );
		}
		catch ( Throwable th ) {
		}

		Frame image = new Frame( study, objectName, frame, parFormat, parMode, parSize, ref );
		
		Helper.DEBUG( "frame.jsp [1]" );
		
		fname = image.getImageFileName();
		
		Helper.DEBUG( "frame.jsp [2]" );
		
		image.checkAndCreateImage();
		
		Helper.DEBUG( "frame.jsp [3]" );
	}
	catch ( Throwable th ) {
		Helper.DEBUG( "Image not found. " + th.toString() );
		IfaceToolbox.printError( is, "Image not found. " + th.toString() );
		return;
	}

	response.setContentType( "image/jpeg" );
	Range range = new Range( request, response );
	
	Helper.DEBUG( "frame.jsp [4]" );

	try {
		range.sendRequestedRange( fname );
		
		Helper.DEBUG( "frame.jsp [5]" );

	}
	catch( Throwable th ) {
		IfaceToolbox.printError( is, "Image not found. " + th.toString() );
		return;
	}

	Helper.DEBUG( "frame.jsp [6]" );

	// be careful not to collect extra newlines after JSP close here
	if ( true )
		return;
%>