<%--
 * Component: iface
 *
 * Description:
 *    HTTP API command to import studies from DICOM media 
 * 
 * This is the official HTTP API command redirecting to the WEB GUI
 *
 * @params:
 *
 *   cBack          URL to go back to after the split operation completes or cancelled
 *                  Special values:
 *                  USE_REFERER : Use the value of the REFERER HTTP header
 *                  USE_DEFAULT : Use default back URL (work list if tabs are displayed, and no back URL if tabs are hidden)
 *   cShowHeaders   use false to hide headers and tabs (default is true)
 *
 *   cUser    user id
 *   cPasswd  password
 *
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
--%><%@
	page import="imagemed.tables.*, imagemed.imsession.*, java.util.*,
			imagemed.util.Helper, imagemed.jsputil.*, imagemed.exception.*, imagemed.lists.*"
	
%><%

	IMSession is = new IMSession( request, response, out );

	boolean showHeaders = !"false".equals( request.getParameter( "cShowHeaders" ) );

	String parBack =  request.getParameter( "cBack" );
	if ( "USE_REFERER".equals( parBack ) ) {
		parBack = request.getHeader( "REFERER" );
	}
	else if ( "USE_DEFAULT".equals( parBack ) ) {
		if ( showHeaders ) {
			parBack = is.httpx_host + GenericUserList.getPrimaryPage( ListDescriptor.LIST_DEFAULT );
		}
		else {
			parBack = null;
		}
	}

	String sessionID =  request.getParameter( "sessionid" );

	StringBuffer url = new StringBuffer( 256 );
	url.append( "/archive/dicomdir.jsp?cMode=Client&cIface=" );
	url.append( showHeaders ? "tabs" : "true" );
	if ( parBack != null ) {
		url.append( "&cBack=" );
		url.append( Helper.URLEncodeUTF8( parBack ) );
	}
	if( sessionID != null ) {
		url.append( "&sessionid=" ).append( Helper.URLEncodeUTF8( sessionID ) );
	}
	
	IfaceToolbox.loginAndRedirect( is, url.toString() );
	
	if ( true ) {
		// To avoid sending any other character on the connection after redirect
		return;
	}
%>