<%--
 ** Component: iface
 **
 ** Description:
 **   interface to initiate user related operations
 **
 ** Parameters:
 **
 **		common Parameters:
 **				cOper           : operation ( "new", "update", "delete" or "getid" )
 ** 
 **		params for "update" or "delete":
 **				cLocid          : ONLY at "update" or "delete": row ID (LOID) of the location to be edited/deleted
 **
 **		params for "getid":
 **				cRegLocID					: the Registered Location ID of the Location to identify
 **				cName						: the Name of the Location to identify
 **
 **		params for "new" or "update":
 **				qe_XXXX					:	Value for field XXXX
 **
 *
 *  Last Updated     : $Author$
 *  Update Date Time : $Date$
 *  RCS File Name    : $RCSfile$
 *  RCS Revision     : $Revision$
 *  Locked by        : $Locker$
 *  Symbolic name    : $Name$
 *  State            : $State$
--%><%@page import="imagemed.types.flag.IMTypeur"%>
<%@page import="imagemed.util.Helper"%>
<%@page import="imagemed.types.IMType.FldValue"%>
<%@
	page import="java.io.*, java.sql.*, java.util.*,
			imagemed.imsession.*, imagemed.exception.*, imagemed.jsputil.*, imagemed.types.IMType,
			imagemed.imtables.*, imagemed.tables.*"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"
	
%><%

	IMSession is = new IMSession( request, response, out );

	is.response.setContentType( "text/plain" );

	if ( !IfaceToolbox.isRegOK( is ) ) {
		IfaceToolbox.printError( is, "Has no registration info for this IP." );
		return;
	}
	
	if ( !is.hasRight( IMTypeur.USER_MANAGE_RIGHT ) ) {
		IfaceToolbox.printError( is, "You don't have the right to perform this operation! (no User Manage right!)" );
		return;
	}
	
	String operStr = request.getParameter( "cOper" );
	if ( operStr == null || operStr.length() == 0 ) {
		IfaceToolbox.printError( is, "Required parameter \"cOper\" is missing!" );
		return;
	}

	String locID = null;
	if( "update".equals( operStr ) || "delete".equals( operStr ) ) {
		locID = request.getParameter( "cLocid" );
		if ( locID == null || locID.length() == 0 ) {
			IfaceToolbox.printError( is, "Required parameter \"cLocid\" is missing!" );
			return;
		}
	}

	is.sessionVariables.setProperty("httpIface", "true");
	
	try {
		if( "new".equals( operStr ) ) {
			locID = LocationToolbox.createNewLocation( is ); 
			if( locID != null ) {
				IfaceToolbox.printOK( is );
				is.out.println( "#ROWID: " + locID );
			}
			else {
				IfaceToolbox.printError( is, "Location ID (row ID) of the newly created record is null!" );
			}
		}
		else if( "getid".equals( operStr ) ) {
			String reglocID = request.getParameter( "cRegLocID" );
			if( reglocID == null ) {
				IfaceToolbox.printError( is, "Required parameter \"cRegLocID\" is missing!" );
			}
			else {
				String label = request.getParameter( "cName" );
				if( label == null ) {
					IfaceToolbox.printError( is, "Required parameter \"cName\" is missing!" );
				}
				else {
					locID = LocationToolbox.getInnerID( reglocID, label );
					if( locID != null ) {
						IfaceToolbox.printOK( is );
						is.out.println( "#ROWID: " + locID );
					}
					else {
						IfaceToolbox.printError( is, "Location ID (row ID) of the record is null!" );
					}
				}
			}
		}
		else if( "update".equals( operStr ) ) {
			LocationToolbox.updateLocation( is, locID );
			IfaceToolbox.printOK( is );
		}
		else if( "delete".equals( operStr ) ) {
			LocationToolbox.deleteLocation( is, locID );
			IfaceToolbox.printOK( is );
		}
	}
	catch( Throwable th ) {
		IfaceToolbox.printError( is, Helper.throwable2String( th ) );
	}
	
	if ( true ) {
		return;
	}
%>
	