<%--
 * Component: iface
 *
 * Description:
 *    Opening the quick view page for the specified study 
 *
 * Params:
 *
 *       SYUI       Instance UID of the study
 *     or
 *       ACCN       Accession Number of the study
 *       PAID       Patient ID of the patient the study should belong to
 *
 *       cMultipleMode    controls how to handle multiple matches on accession numbers
 *                        possible values are
 *                        normal (default):  return an error message
 *                        list            :  popup worklist with matching studies
 *
 *   Login related parameters: 
 *       cUser      user id
 *       cPasswd    password
 *     or
 *       sessionid  session created 
 *
 * Supported fields:
 *   ACCN, PANM, PAID, MODY, DATE
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
--%><%@
	page import="imagemed.imsession.*, java.util.*, imagemed.util.Helper, imagemed.jsputil.IfaceToolbox,
			imagemed.imtables.*, imagemed.tables.*"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%
	IMSession is = new IMSession( request, response, out ); 

	String study = request.getParameter( "SYUI" );
	
	if ( study == null ) {
		String accno = request.getParameter( "ACCN" );
		if ( accno == null ) {
			out.println( "Missing Parameter" );
			return;
		}
		
		is.sessionVariables.setProperty("httpIface", "true");

		String fields[] = { "SYUI", "ACCN", "PAID" };
		IMFieldManager fm = new IMFieldManager( "Dcfields", "Dctypes", "Dcstudy" );

		TableDescriptor tdesc = new TableDescriptor();
		TableParams tparams = new TableParams();
		tparams.setDefaultFields( fields );

		Properties filters = new Properties();
		filters.setProperty( "ACCN", accno );
		filters.setProperty( "FFLG", "\"\"" );
		
		String patient = request.getParameter( "PAID" );
		if ( patient != null ) {
			filters.setProperty( "PAID", patient );
		}
		
		tparams.setFilters( filters );
		tparams.setDefaultSort( new String[]{ "d_DATE", "a_SYUI" } );
		tparams.setDefaultPageSize( -1 );

		tdesc.setTableParams( tparams );
		tdesc.setFieldManager( fm );
		SQLResult result = new SQLResult( tdesc );

		if ( !result.next() ) {
			out.println( "No study found" );
			result.close();
			return;
		}

		study = result.getValue( "SYUI" );
		
		if ( result.next() ) {
			if ( "list".equals( request.getParameter( "cMultipleMode" ) ) ) {

				StringBuilder sb = new StringBuilder( 256 );
				sb.append( is.httpx_host ).append( "/cases/index.jsp?" );
				sb.append( "qf_ACCN=" ).append( Helper.URLEncodeUTF8( accno ) );
				if ( patient != null ) {
					sb.append( "&qf_PAID=" ).append( Helper.URLEncodeUTF8( patient ) );
				}
				if ( is._sid != null ) {
					sb.append( "&sessionid=" ).append( Helper.URLEncodeUTF8( is._sid ) );
				}

				IfaceToolbox.loginAndRedirect( is, sb.toString() );
				return;
			}
			
			out.println( "There are multiple matching studies" );
			result.close();
			return;
		}
		
		result.close();
	}

	if ( study == null ) {
		out.println( "No study was specified or specified study is not found" );
		return;
	}

	StringBuilder sb = new StringBuilder( 256 );
	sb.append( is.httpx_host );
	sb.append( "/cases/index.jsp?cQV=" );
	sb.append( Helper.URLEncodeUTF8( study ) );
	if ( is._sid != null ) {
		sb.append( "&sessionid=" ).append( Helper.URLEncodeUTF8( is._sid ) );
	}

	IfaceToolbox.loginAndRedirect( is, sb.toString() );

	if ( true ) {
		// To avoid sending any other character on the connection after redirect
		return;
	}

%>