<%--
 * Component: iface
 *
 * Description:
 *    Allow viewing study report using Accession Number.
 *
 * The request will be redirected to the reportview page of the study.
 * If there are more than one stufy with the same Accession Number, then the request will
 * be redirected to the worklist page filtered on the Accession Number.
 *
 * This page is intended to be used from the Scheduler Module
 * 
 * @params:
 * 
 *   cUser    user id
 *   cPasswd  password
 *   ACCN     accession number of the study.
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
--%><%@
	page import="imagemed.tables.*, imagemed.imtables.*, imagemed.imsession.*, java.util.*, imagemed.util.Helper,
			imagemed.exception.IMGeneralException, imagemed.jsputil.IfaceToolbox"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%

	IMSession is = new IMSession(request, response, out); 
	String parAccno = request.getParameter("ACCN");
	
	String backURL = request.getHeader("Referer");
	if (null == backURL) {
		backURL = "javascript:self.history.back();";
	}

	if (parAccno == null) {
		throw new IMGeneralException("No report found for this order.", "scheduler/orders.jsp", "Error", backURL);
	}

	is.sessionVariables.setProperty("httpIface", "true");

	String fields[] = { "SYUI", "ACCN" };
	IMFieldManager fm = new IMFieldManager("Dcfields", "Dctypes", "Dcstudy");

	TableDescriptor tdesc = new TableDescriptor();
	TableParams tparams = new TableParams();
	tparams.setDefaultFields(fields);

	Properties filters = new Properties();
	filters.setProperty("ACCN",parAccno);
	tparams.setDefaultFilters(filters);

	tdesc.setTableParams(tparams);
	tdesc.setFieldManager(fm);
	SQLResult result = new SQLResult(tdesc);

	if (!result.next()) {
		// No such study
		throw new IMGeneralException("No report found for this order.", "scheduler/orders.jsp", "Error", backURL);
	}

	String study = result.getValue("SYUI");
	String loc = is.httpx_host + "/cases/reportview.jsp" + "?cGr=" + Helper.URLEncodeUTF8(study);

	if (result.next()) {
		// More than one study
		
		loc = is.httpx_host + "/cases/index.jsp?qf_ACCN=" + Helper.URLEncodeUTF8(parAccno);
	}
	result.close();

	IfaceToolbox.loginAndRedirect(is, loc);

	if (true) {
		// To avoid sending any other character on the connection after redirect
		return;
	}

%>