<%--
 ** Component: iface
 **
 ** Description:
 **   Returns study information in parsable format
 **
 ** Parameters:
 **
 **  @param cStudy           study instance UID
 **
 *
 *  Last Updated     : $Author$
 *  Update Date Time : $Date$
 *  RCS File Name    : $RCSfile$
 *  RCS Revision     : $Revision$
 *  Locked by        : $Locker$
 *  Symbolic name    : $Name$
 *  State            : $State$
--%><%@
	page import="java.util.*, java.sql.*, imagemed.imsession.*, imagemed.jsputil.*, imagemed.util.*,
			imagemed.tables.*, imagemed.imtables.*, imagemed.types.*, imagemed.types.string.*"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%!

	static enum OBJ_TYPE {
		PBR( "pbreport", false ),
		PBD( "pbdictation", false ),
		RAW( "rawdata", false ),
		PDF( "pdf", false ),
		PSG( "presentationstate", false ),
		CAD( "mammocad", false ),
		SRT( "report", false ),
		SRX( "unknownreport", true ),
		OTHER( "unknown", true );
	
	
		String m_tag;
		boolean m_needSOPClass;
		
		OBJ_TYPE( String tag, boolean needSOPClass ) {
			m_tag = tag;
			m_needSOPClass = needSOPClass;
		}
		
		String getTag() {
			return m_tag;
		}
		
		boolean needSOPClass() {
			return m_needSOPClass;
		}
	}


	static OBJ_TYPE sopClass2Tag( String sopClass, String fname ) {
		if ( sopClass.equals( IMEnvBase.getEnv( "PBREPORT_SOPCLASS" ) ) ) {
			// PbR
			return OBJ_TYPE.PBR;
		}
		
		if ( sopClass.equals( IMEnvBase.getEnv( "PBDICTATION_SOPCLASS" ) ) ) {
			// PbD
			return OBJ_TYPE.PBD;
		}
		
		if ( sopClass.equals( "1.2.840.10008.5.1.4.1.1.66" ) ) {
			// RAW Data SOP Class
			return OBJ_TYPE.RAW;
		}
		
		if ( sopClass.equals( "1.2.840.10008.5.1.4.1.1.104.1" ) ) {
			// Encapsulated PDF Storage SOP Class
			return OBJ_TYPE.PDF;
		}
		
		if ( sopClass.equals( "1.2.840.10008.5.1.4.1.1.11.1" ) ) {
			// Presentation State 
			return OBJ_TYPE.PSG;
		}
		
		if ( sopClass.equals( "1.2.840.10008.5.1.4.1.1.88.50" ) ) {
			// Mammography CAD SR object
			return OBJ_TYPE.CAD;
		}
		
		if ( fname.startsWith( "SR" ) ) {
			// structured report file
			if ( fname.startsWith( "SRt" ) ) {
				return OBJ_TYPE.SRT;
			}
			
			return OBJ_TYPE.SRX;
		}

		return OBJ_TYPE.OTHER;
	}

	static String displayXML( String value, String colid ) {
		return Helper.htmlEncode( IMBaseFieldManager.DEFAULTFIELDMANAGER.displayText( value, colid ) );
	}
	
	// TODO: displayProcessable does not convert back iS values
	static String displayTXT( String value, String colid ) {
		return IMBaseFieldManager.DEFAULTFIELDMANAGER.displayText( value, colid );
	}

	static String displayTAB( String value, String colid ) {
		return IMBaseFieldManager.DEFAULTFIELDMANAGER.displayProcessable( value, colid );
	}
	

%><%-- Input Parameters --%><%IMSession is = new IMSession( request, response, out ); 

	String study = request.getParameter( "cStudy" );
	boolean isXML = "xml".equals( request.getParameter( "cFormat" ) );

	is.response.setHeader( "pragma", "no-cache" );
	is.response.setHeader( "Cache-Control" , "no-cache, must-revalidate" );
	is.response.setHeader( "Expiry-Date" , "Friday, 31-Dec-70 23:59:59 GMT" );

	if ( !IfaceToolbox.isRegOK( is ) ) {
		if ( isXML ) {
			IfaceToolbox.printXMLError( is, "Has no registration info for this IP.", true );
		}
		else {
			IfaceToolbox.printError( is, "Has no registration info for this IP." );
		}
		return;
	}

	String sourceStudy = null;
	int mainStatus = -1;
	String orderID = null;

	try {
		ResultSet rs = IMEnv.getDB().createStatement().executeQuery( "select MAINST, ORDERNUM, SRCSTUDY from " +
				IMEnvBase.getEnv("STUDYTBL") + " where STYIUID='" + study + "'" );
		if ( ! rs.first() ) {
			if ( isXML ) {
				IfaceToolbox.printXMLError( is, "Study was not found.", true );
			}
			else {
				IfaceToolbox.printError( is, "Study was not found." );
			}
			return;
		}
		
		mainStatus = rs.getInt( "MAINST" );
		sourceStudy = rs.getString( "SRCSTUDY" );
		orderID = rs.getString( "ORDERNUM" );
		if ( orderID == null || "".equals( orderID ) ) {
				orderID = study;
		}
	}
	catch ( SQLException sqlEx ) {
		if ( isXML ) {
			IfaceToolbox.printXMLError( is, "Error checking study on worklist.", true );
		}
		else {
			IfaceToolbox.printError( is, "Error checking study on worklist." );
		}
		
		return;
	}

	boolean isLinkStudy = !study.equals( sourceStudy );
	QuickViewImages qvImages = null;
	
	try {
		qvImages = QuickViewImages.rmiCollectForAPI( null, study, study );
	}
	catch ( SQLException sqlEx ) {
		if ( isXML ) {
			IfaceToolbox.printXMLError( is, "Error collecting study information.", true );
		}
		else {
			IfaceToolbox.printError( is, "Error collecting study information." );
		}
		return;
	}

	if ( isXML ) {
		IfaceToolbox.openXMLResult( is );
		out.println( "<content>" );
		out.println( "<study>" );
		out.println( " <uid>" + displayXML( study, "SYUI" ) + "</uid>" );
		if ( isLinkStudy ) {
			out.println( " <sourcestudy>" + displayXML( sourceStudy, "SYUI" ) + "</sourcestudy>" );
		}
		out.println( " <dicom>" );
	}
	else {
		is.response.setContentType( "text/plain" );
		out.println("#USERID: " + is.regID);
		out.println("#RESULT: OK");
		out.print( "study\t" + displayTAB( study, "SYUI" ) );
		if ( isLinkStudy ) {
			out.print( "\t" + displayTAB( sourceStudy, "SYUI" ) );
		}
		out.println();
	}

	Vector<QuickViewImages.QuickViewSeries> qvSeries = qvImages.getSeries();
	for ( QuickViewImages.QuickViewSeries series : qvSeries ) {
		if ( isXML ) {
			out.println( "<series>" );
			out.println( " <uid>" + displayXML( series.getSeriesUid(), "SRUI" ) + "</uid>");
			out.println( " <number>" + displayXML( series.getSeriesNumber(), "SRNM" ) + "</number>");
			out.println( " <modality>" + displayXML( series.getModality(), "MODA" ) + "</modality>");
			String dateTime = series.getDateTime();
			if ( dateTime == null || "_".equals( dateTime ) ) {
				dateTime = "";
			}
			if ( !"".equals( dateTime ) ) {
				dateTime = displayTAB( dateTime, "SRDT" );
			}
			out.println( " <datetime>" + dateTime + "</datetime>");
			out.println( " <description>" + displayXML( series.getDescription(), "SRDS" ) + "</description>");
		}
		else {
			out.print( "series" );
			out.print( "\t" + displayTAB( series.getSeriesUid(), "SRUI" ) );
			out.print( "\t" + displayTXT( series.getSeriesNumber(), "SRNM" ) );
			out.print( "\t" + displayTAB( series.getModality(), "MODA" ) );
			out.print( "\t" + displayTAB( series.getDateTime(), "SRDT" ) );
			out.print( "\t" + displayTAB( series.getDescription(), "SRDS" ) );
			out.println();
		}

		if ( isXML ) {
			out.println( "<objects>" );
		}
		
		HashMap<String, QuickViewImages.QuickViewReport> reports = qvImages.getReports();
	
		Vector<QuickViewImages.QuickViewObject> seriesObjects = series.getObjects();
		for ( QuickViewImages.QuickViewObject obj : seriesObjects ) {
			String fname = obj.getFileName();
			String sopClass = obj.getSOPClassUID();
			String docType = obj.getDocumentType(); 
			
			if ( obj instanceof QuickViewImages.QuickViewNonImageObject ) {
				OBJ_TYPE objType = sopClass2Tag( sopClass, fname );
				
				if ( objType == OBJ_TYPE.SRT && ( reports != null ) ) {
					QuickViewImages.QuickViewReport report = reports.get( obj.getSOPInstanceUID() );
					if ( report != null ) {
						if ( isXML ) {
							out.println( "<report>" );
							out.println( " <uid>" + report.getSopInstanceUID() + "</uid>" );
							out.println( " <type>" + report.getType() + "</type>" );
							out.println( " <status>" + report.getStatus() + "</status>" );
							out.println( " <keyimages>" + report.getKeyImages() + "</keyimages>" );
							out.println( "</report>" );
						}
						else {
							out.print( "report" );
							out.print( "\t" + report.getSopInstanceUID() );
							out.print( "\t" + report.getType() );
							out.print( "\t" + report.getStatus() );
							out.print( "\t" + report.getKeyImages() );
							out.println();
						}
						continue;
					}
				}
				
				if ( isXML ) {
					String tag = objType.getTag();
					out.println( "<" + tag + ">" );
					out.println( " <uid>" + displayXML( obj.getSOPInstanceUID(), "SPUI" ) + "</uid>" );
					if ( objType.needSOPClass() ) {
						out.println( " <sopclass>" + Helper.htmlEncode( obj.getSOPClassUID() ) + "</sopclass>" );
					}
					out.println( " <number>" + displayXML( obj.getInstanceNumber(), "IMNM" ) + "</number>" );
					if ( docType != null ) {
						out.println( " <doctype>" + docType + "</doctype>" );
					}
					out.println( "</" + tag + ">" );
				}
				else {
					out.print( objType.getTag() );
					out.print( "\t" + obj.getSOPInstanceUID() );
					if ( docType != null ) {
						out.print( " doctype=\"" + docType + "\"" );
					}
					out.print( "\t" + displayTXT(obj.getInstanceNumber(), "IMNM" ) );
					if ( docType != null ) {
						out.print( "\t" + docType );
					}
					out.println();
				}
				continue;
			}

			QuickViewImages.QuickViewImageObject imgObj = (QuickViewImages.QuickViewImageObject) obj;
			int frames = imgObj.getFrameCount();
			int cols = imgObj.getCols();
			int rows = imgObj.getRows();

			if ( isXML ) {
				out.println( "<image>" );
				out.println( " <uid>" + imgObj.getSOPInstanceUID() + "</uid>" );
				out.println( " <sopclass>" + Helper.htmlEncode( imgObj.getSOPClassUID() ) + "</sopclass>" );
				out.println( " <number>" + displayXML( imgObj.getInstanceNumber(), "IMNM" ) + "</number>" );
				out.println( " <frames>" + imgObj.getFrameCount() + "</frames>" );
				out.println( " <cols>" + imgObj.getCols() + "</cols>" );
				out.println( " <rows>" + imgObj.getRows() + "</rows>" );
				if ( docType != null ) {
					out.println( " <doctype>" + docType + "</doctype>" );
				}
				out.println( "</image>" );
			}
			else {
				out.print( "image" );
				out.print( "\t" + imgObj.getSOPInstanceUID() );
				out.print( "\t" + imgObj.getSOPClassUID() );
				out.print( "\t" + displayTXT( imgObj.getInstanceNumber(), "IMNM" ) );
				out.print( "\t" + imgObj.getFrameCount() );
				out.print( "\t" + imgObj.getCols() );
				out.print( "\t" + imgObj.getRows() );
				if ( docType != null ) {
					out.print( "\t" + docType );
				}
				out.println();
			}
		} // for obj

		if ( isXML ) {
			out.println( "</objects>" );
			out.println( "</series>" );
		}
	} // for series

	if ( isXML ) {
		out.println( "</dicom>" );
	}
	
	Vector<AttachmentManager.SchedulerAttachment> orderAttachments = AttachmentManager.listAttachments( orderID );
	if ( orderAttachments != null && !orderAttachments.isEmpty() ) {
			
		if ( isXML ) {
			out.println( "<nondicom>" );
		}
		else {
			out.println( "nondicom" );
		}

		for ( AttachmentManager.SchedulerAttachment att : orderAttachments ) {
			String docType = att.getDocType();
			String attName = att.getName();
			AttachmentManager.TYPE type = att.getType();
			if ( type.equals( AttachmentManager.TYPE.PDF ) ) {
				if ( isXML ) {
					out.println( "<attdocument>" );
					out.println( " <name>" + attName + "</name>" );
					out.println( " <doctype>" + docType + "</doctype>" );
					out.println( "</attdocument>" );
				}
				else {
					out.print( "attdocument" );
					out.print( "\t" + attName );
					out.print( "\t" + docType );
					out.println();
				}
					
				continue;
			}
				
			Vector<AttachmentManager.Frame> frames = att.getFrames();
			if ( isXML ) {
				out.println( "<attimage>" );
				out.println( " <name>" + attName + "</name>" );
				out.println( " <doctype>" + docType + "</doctype>" );
			}
			else {
				out.print( "attimage" );
				out.print( "\t" + attName );
				out.print( "\t" + docType );
				out.println();
			}

			out.println( "<attframes>" );
			for ( AttachmentManager.Frame frame : frames ) {
				String frameName = frame.getName();
				int frameNum = frame.getNum();
				// TODO : Cols x Rows ?? - but we don't have the information stored an easily accessible 
				if ( isXML ) {
					out.println( "<attframe>" );
					out.println( " <number>" + frameNum + "</number>" );
					out.println( "</attframe>" );
				}
				else {
					out.print( "attframe" );
					out.print( "\t" + frameNum );
					out.println();
				}
			}
				
			if ( isXML ) {
				out.println( "</attframes>" );
				out.println( "</attimage>" );
			}
				
		}
			
		if ( isXML ) {
			out.println( "</nondicom>" );
		}
	}
	
	if ( isXML ) {
		out.println( "</study>" );
		out.println( "</content>" );
		IfaceToolbox.closeXMLResult( is );
	}%><%--result.getDebug()--%>
