<%--
 * Component: iface
 *
 * This JSP page is used to testing Callback Hooks by placing callback notifications received in
 * HTTP requests to temporary files   
 *
 * @param cCallbackList   File containing information on event(s) registered for the callback
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
--%><%@
	page errorPage="../main/exceptionHandler.jsp"
	language="java"
	contentType="text/plain; charset=ISO-8859-1"

%><%@
	page import="java.io.*, java.util.*, imagemed.imsession.*, imagemed.jsputil.*, imagemed.util.*"

%><%

	IMSession is = new IMSession( request, response, out );
	
	if ( !IfaceToolbox.isRegOK( is ) ) {
		Helper.ERRORLOG( "testCallback", "no rights" );
		response.sendError( 500, "Access denied" );
		return;
	}

	File tempDir = new File( IMEnvBase.getEnv( "TMP" ) + "/callback_notifications" );
	tempDir.mkdirs();
	
	MultipartRequest mpr = new MultipartRequest( is, tempDir.getAbsolutePath() );

	String fileName = mpr.getParameter( "cCallbackList" );
	
	String callbackFileName = mpr.getFileNameFor( "cCallbackList" );
	
	if ( callbackFileName == null ) {
		Helper.ERRORLOG( "testCallback", "cCallbackList is missing" );
		response.sendError( 500, "Bad parameters" );
		return;
	}

	File callBackFile =  new File( fileName );
	
	if ( ! callBackFile.exists() ) {
		Helper.ERRORLOG( "testCallback", "Callback file " + fileName + " does not exist" );
		response.sendError( 500, "Processing error" );
		return;
	}

	Helper.renameToNotThrowsException( callBackFile, new File ( tempDir, callbackFileName ) );
	
	String scriptName = request.getParameter( "cScript" );
	if ( scriptName != null ) {
		File scriptFile = new File( IMEnvBase.getEnv( "VAR" ) + "/callback/" + scriptName ); 
		if ( scriptFile.exists() ) {
			Vector<String> cmd = new Vector<String>();
			cmd.add( scriptFile.getAbsolutePath() );
			cmd.add( "-f" );
			cmd.add( callBackFile.getAbsolutePath() );
			
			RunCommandResult res = Helper.runCommandEx( cmd.toArray( new String[ 0 ] ), null );
			if ( res.getExitCode() != 0 ) {
				Helper.ERRORLOG( "testCallback: Running callback script " + scriptFile.getName() + " for " + callbackFileName + " FAILED: [" + res.getError() + "]" );
				response.setContentType( "text/plain" );
				response.setContentLength( 2 );
				out.println( "FAILED" );
				out.println( "Error: " + res.getError() ); // the error stream of the script
				return;
			}
		}
	}

	
	Helper.INFOLOG( "testCallback: Callback notification is received: " + callbackFileName + " [" + callBackFile.length() + "]" );
	
	response.setContentType( "text/plain" );
	response.setContentLength( 2 );
	out.print( "OK" );
	
	if ( true ) {
		return;
	}
%>